<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Processors/ScopeStripper.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Processors/ScopeStripper.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Processors/ScopeStripper.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> *</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line11"></a><span class="lineno"> 11</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html">ScopeStripper</a>(Processor, ASG.Visitor):</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Strip common prefix from the declaration's name.</span></span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-string">    Keep a list of root nodes, such that children whos parent</span></span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-string">    scopes are not accepted but which themselfs are correct can</span></span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-string">    be maintained as new root nodes.&quot;&quot;&quot;</span></span>
<a id="line17"></a><span class="lineno"> 17</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">    scope = Parameter(<span class="py-string">''</span>, <span class="py-string">'strip all but the given scope'</span>)</span>
<a id="line19"></a><span class="lineno"> 19</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#__init__">__init__</a>(self, **kwds):</span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">        Processor.__init__(self, **kwds)</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">        self.declarations = []</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">        self.inside = False</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">        self._scope = ()</span>
<a id="line26"></a><span class="lineno"> 26</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#process">process</a>(self, ir, **kwds):</span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.scope: <span class="py-keyword">raise</span> MissingArgument(<span class="py-string">'scope'</span>)</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">        self.ir = self.merge_input(ir)</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">        <span class="py-keyword">if</span> <span class="py-string">'::'</span> <span class="py-keyword">in</span> self.scope:</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">            self._scope = tuple(self.scope.split(<span class="py-string">'::'</span>))</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">            self._scope = tuple(self.scope.split(<span class="py-string">'.'</span>))</span>
<a id="line36"></a><span class="lineno"> 36</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">        <span class="py-comment"># strip prefixes and remove non-matching declarations</span></span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">        self.strip_declarations(self.ir.asg.declarations)</span>
<a id="line39"></a><span class="lineno"> 39</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">        <span class="py-comment"># Remove types not in strip</span></span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">        self.strip_types(self.ir.asg.types)</span>
<a id="line42"></a><span class="lineno"> 42</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">        <span class="py-keyword">return</span> self.output_and_return_ir()</span>
<a id="line44"></a><span class="lineno"> 44</span>
<a id="line45"></a><span class="lineno"> 45</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#strip_name">strip_name</a>(self, name):</span>
<a id="line47"></a><span class="lineno"> 47</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">        depth = len(self._scope)</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">        <span class="py-keyword">if</span> name[:depth] == self._scope:</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">            <span class="py-keyword">if</span> len(name) == depth: <span class="py-keyword">return</span> None</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">            <span class="py-keyword">return</span> name[depth:]</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">        <span class="py-keyword">return</span> None</span>
<a id="line53"></a><span class="lineno"> 53</span>
<a id="line54"></a><span class="lineno"> 54</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#strip_declarations">strip_declarations</a>(self, declarations):</span>
<a id="line56"></a><span class="lineno"> 56</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">        <span class="py-keyword">for</span> decl <span class="py-keyword">in</span> declarations:</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">            decl.accept(self)</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">        declarations[:] = self.declarations</span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#strip_types">strip_types</a>(self, types):</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">        <span class="py-comment"># Remove the empty type (caused by C++ with extract_tails)</span></span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">        <span class="py-keyword">if</span> types.has_key(()): <span class="py-keyword">del</span> types[()]</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">        <span class="py-keyword">for</span> name, type <span class="py-keyword">in</span> types.items():</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">            <span class="py-keyword">try</span>:</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">                <span class="py-keyword">del</span> types[name]</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">                name = self.strip_name(name)</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">                <span class="py-keyword">if</span> name:</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">                    type.name = name</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">                    types[name] = type</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">            <span class="py-keyword">except</span>:</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">                <span class="py-keyword">print</span> <span class="py-string">&quot;ERROR Processing:&quot;</span>, name, types[name]</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">                <span class="py-keyword">raise</span></span>
<a id="line75"></a><span class="lineno"> 75</span>
<a id="line76"></a><span class="lineno"> 76</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#strip">strip</a>(self, declaration):</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">        <span class="py-string">&quot;&quot;&quot;test whether the declaration matches one of the prefixes, strip</span></span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line"><span class="py-string">        it off, and return success. Success means that the declaration matches</span></span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line"><span class="py-string">        the prefix set and thus should not be removed from the ASG.&quot;&quot;&quot;</span></span>
<a id="line81"></a><span class="lineno"> 81</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">        passed = False</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self._scope: <span class="py-keyword">return</span> True</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">        depth = len(self._scope)</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">        name = declaration.name</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        <span class="py-keyword">if</span> name[:depth] == self._scope <span class="py-keyword">and</span> len(name) &gt; depth:</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">            <span class="py-keyword">if</span> self.verbose: <span class="py-keyword">print</span> <span class="py-string">&quot;symbol&quot;</span>, <span class="py-string">'::'</span>.join(name),</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">            declaration.name = name[depth:]</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">            <span class="py-keyword">if</span> self.verbose: <span class="py-keyword">print</span> <span class="py-string">&quot;stripped to&quot;</span>, <span class="py-string">'::'</span>.join(declaration.name)</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">            passed = True</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">        <span class="py-keyword">if</span> self.verbose <span class="py-keyword">and</span> <span class="py-keyword">not</span> passed:</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">            <span class="py-keyword">print</span> <span class="py-string">&quot;symbol&quot;</span>, <span class="py-string">'::'</span>.join(declaration.name), <span class="py-string">&quot;removed&quot;</span></span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">        <span class="py-keyword">return</span> passed</span>
<a id="line94"></a><span class="lineno"> 94</span>
<a id="line95"></a><span class="lineno"> 95</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#visit_scope">visit_scope</a>(self, scope):</span>
<a id="line97"></a><span class="lineno"> 97</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">        root = self.strip(scope) <span class="py-keyword">and</span> <span class="py-keyword">not</span> self.inside</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">        <span class="py-keyword">if</span> root:</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">            self.inside = True</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">            self.declarations.append(scope)</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">        <span class="py-keyword">for</span> declaration <span class="py-keyword">in</span> scope.declarations:</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">            declaration.accept(self)</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">        <span class="py-keyword">if</span> root: self.inside = False</span>
<a id="line105"></a><span class="lineno">105</span>
<a id="line106"></a><span class="lineno">106</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#visit_class">visit_class</a>(self, class_):</span>
<a id="line108"></a><span class="lineno">108</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">        self.visit_scope(class_)</span>
<a id="line110"></a><span class="lineno">110</span>
<a id="line111"></a><span class="lineno">111</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#visit_class_template">visit_class_template</a>(self, class_):</span>
<a id="line113"></a><span class="lineno">113</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">        self.visit_class(class_)</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">        templ = class_.template</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">        <span class="py-keyword">if</span> templ:</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">            name = self.strip_name(templ.name)</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">            <span class="py-keyword">if</span> name: templ.name = name</span>
<a id="line119"></a><span class="lineno">119</span>
<a id="line120"></a><span class="lineno">120</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#visit_declaration">visit_declaration</a>(self, decl):</span>
<a id="line122"></a><span class="lineno">122</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">        <span class="py-keyword">if</span> self.strip(decl) <span class="py-keyword">and</span> <span class="py-keyword">not</span> self.inside:</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">            self.declarations.append(decl)</span>
<a id="line125"></a><span class="lineno">125</span>
<a id="line126"></a><span class="lineno">126</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#visit_enumerator">visit_enumerator</a>(self, enumerator):</span>
<a id="line128"></a><span class="lineno">128</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">        self.strip(enumerator)</span>
<a id="line130"></a><span class="lineno">130</span>
<a id="line131"></a><span class="lineno">131</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#visit_enum">visit_enum</a>(self, enum):</span>
<a id="line133"></a><span class="lineno">133</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">        self.visit_declaration(enum)</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">        <span class="py-keyword">for</span> e <span class="py-keyword">in</span> enum.enumerators:</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">            e.accept(self)</span>
<a id="line137"></a><span class="lineno">137</span>
<a id="line138"></a><span class="lineno">138</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#visit_function">visit_function</a>(self, function):</span>
<a id="line140"></a><span class="lineno">140</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">        self.visit_declaration(function)</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">        <span class="py-keyword">for</span> parameter <span class="py-keyword">in</span> function.parameters:</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">            parameter.accept(self)</span>
<a id="line144"></a><span class="lineno">144</span>
<a id="line145"></a><span class="lineno">145</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#visit_parameter">visit_parameter</a>(self, parameter):</span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">        self.strip(parameter)</span>
<a id="line149"></a><span class="lineno">149</span>
<a id="line150"></a><span class="lineno">150</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#visit_function_template">visit_function_template</a>(self, function):</span>
<a id="line152"></a><span class="lineno">152</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">        self.visit_function(function)</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">        <span class="py-keyword">if</span> function.template:</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">            name = self.strip_name(function.template.name)</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">            <span class="py-keyword">if</span> name: function.template.name = name</span>
<a id="line157"></a><span class="lineno">157</span>
<a id="line158"></a><span class="lineno">158</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#visit_operation">visit_operation</a>(self, operation):</span>
<a id="line160"></a><span class="lineno">160</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">        self.visit_function(operation)</span>
<a id="line162"></a><span class="lineno">162</span>
<a id="line163"></a><span class="lineno">163</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#visit_operation_template">visit_operation_template</a>(self, operation):</span>
<a id="line165"></a><span class="lineno">165</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">        self.visit_function_template(operation)</span>
<a id="line167"></a><span class="lineno">167</span>
<a id="line168"></a><span class="lineno">168</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ScopeStripper/ScopeStripper.html#visit_meta_module">visit_meta_module</a>(self, module):</span>
<a id="line170"></a><span class="lineno">170</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">        self.visit_scope(module)</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> module.module_declarations:</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">            name = self.strip_name(d.name)</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">            <span class="py-keyword">if</span> name: d.name = name</span>
<a id="line175"></a><span class="lineno">175</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:14 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
